package com.uoc.cclavero.freeauthenticator.interfaces;

import android.arch.lifecycle.ComputableLiveData;
import android.arch.lifecycle.LiveData;
import android.arch.persistence.db.SupportSQLiteStatement;
import android.arch.persistence.room.EntityDeletionOrUpdateAdapter;
import android.arch.persistence.room.EntityInsertionAdapter;
import android.arch.persistence.room.InvalidationTracker.Observer;
import android.arch.persistence.room.RoomDatabase;
import android.arch.persistence.room.RoomSQLiteQuery;
import android.database.Cursor;
import android.support.annotation.NonNull;
import com.uoc.cclavero.freeauthenticator.entities.Key;
import java.lang.Integer;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

@SuppressWarnings("unchecked")
public class KeyDAO_Impl implements KeyDAO {
  private final RoomDatabase __db;

  private final EntityInsertionAdapter __insertionAdapterOfKey;

  private final EntityDeletionOrUpdateAdapter __deletionAdapterOfKey;

  private final EntityDeletionOrUpdateAdapter __updateAdapterOfKey;

  public KeyDAO_Impl(RoomDatabase __db) {
    this.__db = __db;
    this.__insertionAdapterOfKey = new EntityInsertionAdapter<Key>(__db) {
      @Override
      public String createQuery() {
        return "INSERT OR ABORT INTO `key_table`(`id`,`privateKey`,`token`,`description`,`order`) VALUES (?,?,?,?,?)";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Key value) {
        if (value.getId() == null) {
          stmt.bindNull(1);
        } else {
          stmt.bindLong(1, value.getId());
        }
        if (value.getPrivateKey() == null) {
          stmt.bindNull(2);
        } else {
          stmt.bindString(2, value.getPrivateKey());
        }
        if (value.getToken() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, value.getToken());
        }
        if (value.getDescription() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getDescription());
        }
        if (value.getOrder() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindLong(5, value.getOrder());
        }
      }
    };
    this.__deletionAdapterOfKey = new EntityDeletionOrUpdateAdapter<Key>(__db) {
      @Override
      public String createQuery() {
        return "DELETE FROM `key_table` WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Key value) {
        if (value.getId() == null) {
          stmt.bindNull(1);
        } else {
          stmt.bindLong(1, value.getId());
        }
      }
    };
    this.__updateAdapterOfKey = new EntityDeletionOrUpdateAdapter<Key>(__db) {
      @Override
      public String createQuery() {
        return "UPDATE OR ABORT `key_table` SET `id` = ?,`privateKey` = ?,`token` = ?,`description` = ?,`order` = ? WHERE `id` = ?";
      }

      @Override
      public void bind(SupportSQLiteStatement stmt, Key value) {
        if (value.getId() == null) {
          stmt.bindNull(1);
        } else {
          stmt.bindLong(1, value.getId());
        }
        if (value.getPrivateKey() == null) {
          stmt.bindNull(2);
        } else {
          stmt.bindString(2, value.getPrivateKey());
        }
        if (value.getToken() == null) {
          stmt.bindNull(3);
        } else {
          stmt.bindString(3, value.getToken());
        }
        if (value.getDescription() == null) {
          stmt.bindNull(4);
        } else {
          stmt.bindString(4, value.getDescription());
        }
        if (value.getOrder() == null) {
          stmt.bindNull(5);
        } else {
          stmt.bindLong(5, value.getOrder());
        }
        if (value.getId() == null) {
          stmt.bindNull(6);
        } else {
          stmt.bindLong(6, value.getId());
        }
      }
    };
  }

  @Override
  public void insert(Key key) {
    __db.beginTransaction();
    try {
      __insertionAdapterOfKey.insert(key);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void delete(Key key) {
    __db.beginTransaction();
    try {
      __deletionAdapterOfKey.handle(key);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public void update(Key key) {
    __db.beginTransaction();
    try {
      __updateAdapterOfKey.handle(key);
      __db.setTransactionSuccessful();
    } finally {
      __db.endTransaction();
    }
  }

  @Override
  public LiveData<List<Key>> getAllKeys() {
    final String _sql = "SELECT * from key_table ORDER BY `order` ASC";
    final RoomSQLiteQuery _statement = RoomSQLiteQuery.acquire(_sql, 0);
    return new ComputableLiveData<List<Key>>() {
      private Observer _observer;

      @Override
      protected List<Key> compute() {
        if (_observer == null) {
          _observer = new Observer("key_table") {
            @Override
            public void onInvalidated(@NonNull Set<String> tables) {
              invalidate();
            }
          };
          __db.getInvalidationTracker().addWeakObserver(_observer);
        }
        final Cursor _cursor = __db.query(_statement);
        try {
          final int _cursorIndexOfId = _cursor.getColumnIndexOrThrow("id");
          final int _cursorIndexOfPrivateKey = _cursor.getColumnIndexOrThrow("privateKey");
          final int _cursorIndexOfToken = _cursor.getColumnIndexOrThrow("token");
          final int _cursorIndexOfDescription = _cursor.getColumnIndexOrThrow("description");
          final int _cursorIndexOfOrder = _cursor.getColumnIndexOrThrow("order");
          final List<Key> _result = new ArrayList<Key>(_cursor.getCount());
          while(_cursor.moveToNext()) {
            final Key _item;
            final String _tmpPrivateKey;
            _tmpPrivateKey = _cursor.getString(_cursorIndexOfPrivateKey);
            final String _tmpToken;
            _tmpToken = _cursor.getString(_cursorIndexOfToken);
            final String _tmpDescription;
            _tmpDescription = _cursor.getString(_cursorIndexOfDescription);
            _item = new Key(_tmpDescription,_tmpPrivateKey,_tmpToken);
            final Integer _tmpId;
            if (_cursor.isNull(_cursorIndexOfId)) {
              _tmpId = null;
            } else {
              _tmpId = _cursor.getInt(_cursorIndexOfId);
            }
            _item.setId(_tmpId);
            final Integer _tmpOrder;
            if (_cursor.isNull(_cursorIndexOfOrder)) {
              _tmpOrder = null;
            } else {
              _tmpOrder = _cursor.getInt(_cursorIndexOfOrder);
            }
            _item.setOrder(_tmpOrder);
            _result.add(_item);
          }
          return _result;
        } finally {
          _cursor.close();
        }
      }

      @Override
      protected void finalize() {
        _statement.release();
      }
    }.getLiveData();
  }
}
