package com.uoc.cclavero.freeauthenticator.data;

import android.arch.persistence.db.SupportSQLiteDatabase;
import android.arch.persistence.db.SupportSQLiteOpenHelper;
import android.arch.persistence.db.SupportSQLiteOpenHelper.Callback;
import android.arch.persistence.db.SupportSQLiteOpenHelper.Configuration;
import android.arch.persistence.room.DatabaseConfiguration;
import android.arch.persistence.room.InvalidationTracker;
import android.arch.persistence.room.RoomOpenHelper;
import android.arch.persistence.room.RoomOpenHelper.Delegate;
import android.arch.persistence.room.util.TableInfo;
import android.arch.persistence.room.util.TableInfo.Column;
import android.arch.persistence.room.util.TableInfo.ForeignKey;
import android.arch.persistence.room.util.TableInfo.Index;
import com.uoc.cclavero.freeauthenticator.interfaces.KeyDAO;
import com.uoc.cclavero.freeauthenticator.interfaces.KeyDAO_Impl;
import java.lang.IllegalStateException;
import java.lang.Override;
import java.lang.String;
import java.lang.SuppressWarnings;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;

@SuppressWarnings("unchecked")
public class KeyRoomDatabase_Impl extends KeyRoomDatabase {
  private volatile KeyDAO _keyDAO;

  @Override
  protected SupportSQLiteOpenHelper createOpenHelper(DatabaseConfiguration configuration) {
    final SupportSQLiteOpenHelper.Callback _openCallback = new RoomOpenHelper(configuration, new RoomOpenHelper.Delegate(1) {
      @Override
      public void createAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("CREATE TABLE IF NOT EXISTS `key_table` (`id` INTEGER PRIMARY KEY AUTOINCREMENT, `privateKey` TEXT NOT NULL, `token` TEXT, `description` TEXT NOT NULL, `order` INTEGER)");
        _db.execSQL("CREATE UNIQUE INDEX `index_key_table_order` ON `key_table` (`order`)");
        _db.execSQL("CREATE TABLE IF NOT EXISTS room_master_table (id INTEGER PRIMARY KEY,identity_hash TEXT)");
        _db.execSQL("INSERT OR REPLACE INTO room_master_table (id,identity_hash) VALUES(42, \"276b4099e64f42a719228312b2c60dfa\")");
      }

      @Override
      public void dropAllTables(SupportSQLiteDatabase _db) {
        _db.execSQL("DROP TABLE IF EXISTS `key_table`");
      }

      @Override
      protected void onCreate(SupportSQLiteDatabase _db) {
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onCreate(_db);
          }
        }
      }

      @Override
      public void onOpen(SupportSQLiteDatabase _db) {
        mDatabase = _db;
        internalInitInvalidationTracker(_db);
        if (mCallbacks != null) {
          for (int _i = 0, _size = mCallbacks.size(); _i < _size; _i++) {
            mCallbacks.get(_i).onOpen(_db);
          }
        }
      }

      @Override
      protected void validateMigration(SupportSQLiteDatabase _db) {
        final HashMap<String, TableInfo.Column> _columnsKeyTable = new HashMap<String, TableInfo.Column>(5);
        _columnsKeyTable.put("id", new TableInfo.Column("id", "INTEGER", false, 1));
        _columnsKeyTable.put("privateKey", new TableInfo.Column("privateKey", "TEXT", true, 0));
        _columnsKeyTable.put("token", new TableInfo.Column("token", "TEXT", false, 0));
        _columnsKeyTable.put("description", new TableInfo.Column("description", "TEXT", true, 0));
        _columnsKeyTable.put("order", new TableInfo.Column("order", "INTEGER", false, 0));
        final HashSet<TableInfo.ForeignKey> _foreignKeysKeyTable = new HashSet<TableInfo.ForeignKey>(0);
        final HashSet<TableInfo.Index> _indicesKeyTable = new HashSet<TableInfo.Index>(1);
        _indicesKeyTable.add(new TableInfo.Index("index_key_table_order", true, Arrays.asList("order")));
        final TableInfo _infoKeyTable = new TableInfo("key_table", _columnsKeyTable, _foreignKeysKeyTable, _indicesKeyTable);
        final TableInfo _existingKeyTable = TableInfo.read(_db, "key_table");
        if (! _infoKeyTable.equals(_existingKeyTable)) {
          throw new IllegalStateException("Migration didn't properly handle key_table(com.uoc.cclavero.freeauthenticator.entities.Key).\n"
                  + " Expected:\n" + _infoKeyTable + "\n"
                  + " Found:\n" + _existingKeyTable);
        }
      }
    }, "276b4099e64f42a719228312b2c60dfa", "e2bd031b3aef29edb846116ee84460bf");
    final SupportSQLiteOpenHelper.Configuration _sqliteConfig = SupportSQLiteOpenHelper.Configuration.builder(configuration.context)
        .name(configuration.name)
        .callback(_openCallback)
        .build();
    final SupportSQLiteOpenHelper _helper = configuration.sqliteOpenHelperFactory.create(_sqliteConfig);
    return _helper;
  }

  @Override
  protected InvalidationTracker createInvalidationTracker() {
    return new InvalidationTracker(this, "key_table");
  }

  @Override
  public void clearAllTables() {
    super.assertNotMainThread();
    final SupportSQLiteDatabase _db = super.getOpenHelper().getWritableDatabase();
    try {
      super.beginTransaction();
      _db.execSQL("DELETE FROM `key_table`");
      super.setTransactionSuccessful();
    } finally {
      super.endTransaction();
      _db.query("PRAGMA wal_checkpoint(FULL)").close();
      if (!_db.inTransaction()) {
        _db.execSQL("VACUUM");
      }
    }
  }

  @Override
  public KeyDAO keyDAO() {
    if (_keyDAO != null) {
      return _keyDAO;
    } else {
      synchronized(this) {
        if(_keyDAO == null) {
          _keyDAO = new KeyDAO_Impl(this);
        }
        return _keyDAO;
      }
    }
  }
}
