package com.uoc.cclavero.freeauthenticator.data;

import android.arch.persistence.room.Database;

import android.arch.persistence.room.Room;
import android.arch.persistence.room.RoomDatabase;
import android.content.Context;

import com.uoc.cclavero.freeauthenticator.entities.Key;
import com.uoc.cclavero.freeauthenticator.interfaces.KeyDAO;

@Database(entities = {Key.class}, version = 1, exportSchema = false)
public abstract class KeyRoomDatabase extends RoomDatabase {
    public abstract KeyDAO keyDAO();

    private static volatile KeyRoomDatabase INSTANCE;

    public static synchronized KeyRoomDatabase getDatabase(final Context context) {
        if (INSTANCE == null) {
            INSTANCE = Room.databaseBuilder(context.getApplicationContext(),
                    KeyRoomDatabase.class, "key_database")
                    .build();
        }
        return INSTANCE;
    }
}
