package com.uoc.cclavero.freeauthenticator.data;

import android.app.Application;
import android.arch.lifecycle.AndroidViewModel;
import android.arch.lifecycle.LiveData;

import com.uoc.cclavero.freeauthenticator.entities.Key;

import java.util.List;

public class KeyViewModel extends AndroidViewModel {

    private KeyRepository repository;

    private LiveData<List<Key>> allKeys;

    public KeyViewModel (Application application) {
        super(application);
        repository = new KeyRepository(application);
        allKeys = repository.getAllKeys();
    }

    public LiveData<List<Key>> getAllKeys() { return allKeys; }

    public void insert(Key key) { repository.insert(key); }

    public void update(Key key) { repository.update(key); }

    public void delete(Key key) { repository.delete(key); }
}
