package com.uoc.cclavero.freeauthenticator.dialogs;

import android.content.Context;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.design.widget.BottomSheetDialogFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;

import com.uoc.cclavero.freeauthenticator.R;

public class AddKeyDialog extends BottomSheetDialogFragment {

    private AddKeyDialogListener listener;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View v = inflater.inflate(R.layout.content_add_key_menu, container, false);

        LinearLayout qr_scanner = v.findViewById(R.id.scan_barcode);
        LinearLayout keyboard_input = v.findViewById(R.id.keyboard_input);

        qr_scanner.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onButtonClicked("qr_scanner");
                dismiss();
            }
        });

        keyboard_input.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onButtonClicked("keyboard_input");
                dismiss();
            }
        });

        return v;
    }

    public interface AddKeyDialogListener{
        void onButtonClicked(String text);
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);

        try{
            listener = (AddKeyDialogListener) context;
        }catch (ClassCastException e){
            throw new ClassCastException(context.toString() + "must implement AddKeyDialogListener");
        }

    }
}
