package com.uoc.cclavero.freeauthenticator.entities;

import android.arch.persistence.room.Entity;
import android.arch.persistence.room.Ignore;
import android.arch.persistence.room.Index;
import android.support.annotation.NonNull;
import android.arch.persistence.room.ColumnInfo;
import android.arch.persistence.room.PrimaryKey;


@Entity(tableName = "key_table", indices = {@Index(value={"order"}, unique = true)})
public class Key {

    @PrimaryKey(autoGenerate = true)
    private Integer id;

    @NonNull
    @ColumnInfo(name="privateKey")
    private String privateKey;

    @ColumnInfo(name="token")
    private String token = "";

    @NonNull
    @ColumnInfo(name="description")
    private String description;

    @ColumnInfo(name="order")
    private Integer order;

    @Ignore
    public Key(@NonNull String description, @NonNull String privateKey) {
        this.description = description;
        this.privateKey = privateKey;
    }

    public Key(@NonNull String description, @NonNull String privateKey, @NonNull String token) {
        this.description = description;
        this.privateKey = privateKey;
        this.token = token;
    }

    public Integer getId(){return this.id;}

    public void setId(Integer id) { this.id = id; }

    public String getPrivateKey(){return this.privateKey;}

    public void setPrivateKey(@NonNull String privateKey) { this.privateKey = privateKey; }

    public String getDescription(){return this.description;}

    public void setDescription(String description) { this.description = description; }

    public Integer getOrder(){return this.order;}

    public void setOrder(@NonNull Integer order) { this.order = order; }

    public String getToken() { return token; }

    public void setToken(String token) { this.token = token; }
}
