package com.uoc.cclavero.freeauthenticator.helpers;

import android.os.Environment;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

public class ExternalStorageHelper {

    public static boolean isExternalStorageWritable() {
        String state = Environment.getExternalStorageState();
        if (Environment.MEDIA_MOUNTED.equals(state)) {
            return true;
        }
        return false;
    }

    public static File storeFileInPublicStorageFolder(String filename) {
        try {
            File file = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOCUMENTS), filename);
            file.createNewFile();
            return file;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    public static boolean writeStringToFile(File file, String content) {
        try{
            FileOutputStream stream = new FileOutputStream(file);
            try {
                stream.write(content.getBytes());
            } finally {
                stream.close();
            }
            return true;
        }catch (Exception e) {
            return false;
        }
    }
}
