package com.uoc.cclavero.freeauthenticator.interfaces;

import android.arch.lifecycle.LiveData;
import android.arch.persistence.room.Dao;
import android.arch.persistence.room.Delete;
import android.arch.persistence.room.Insert;
import android.arch.persistence.room.Query;
import android.arch.persistence.room.Update;

import com.uoc.cclavero.freeauthenticator.entities.Key;

import java.util.List;

@Dao
public interface KeyDAO
{

    @Insert
    void insert(Key key);

    @Update
    void update(Key key);

    @Delete
    void delete(Key key);

    @Query("SELECT * from key_table ORDER BY `order` ASC")
    LiveData<List<Key>> getAllKeys();
}