package com.uoc.cclavero.freeauthenticator;

import com.uoc.cclavero.freeauthenticator.activities.CreateBackupActivity;

import org.junit.Test;

import static junit.framework.TestCase.assertTrue;
import static junit.framework.TestCase.assertFalse;

public class UnitTestCheckPassword {

    @Test
    public void password_is_too_short() { assertFalse(CreateBackupActivity.checkPassword("123")); }

    @Test
    public void password_only_blank_spaces_is_not_valid() { assertFalse(CreateBackupActivity.checkPassword("    ")); }

    @Test
    public void password_is_valid() { assertTrue(CreateBackupActivity.checkPassword("abcd")); }

    @Test
    public void password_with_white_spaces_is_valid() { assertTrue(CreateBackupActivity.checkPassword("ab c")); }

    @Test
    public void password_start_and_end_with_blank_spaces_is_not_valid() { assertFalse(CreateBackupActivity.checkPassword(" abc ")); }

    @Test
    public void password_start_and_end_with_blank_spaces_is_valid() { assertTrue(CreateBackupActivity.checkPassword(" abcd ")); }

}
